/************************************************************************ *********
 * Proiect Proiectarea cu Microprocesoare: Afisaj Matrice Leduri
 * Realizarea unui joc de lumini pe o matrice 8x8 in doua culori
 * Oprea Ioana Ana-Maria
 * 331 CB
 *********************************************************************************/

#include <avr\io.h>
#include <avr\interrupt.h>

#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>


// setare timer
void initTimer() {
	OCR1A = 500;						
	TCCR1B |= (_BV(CS12) | _BV(CS10)); 											
	TCCR1B &= ~_BV(CS11) ;			 	
	TCCR1A &= ~(_BV(WGM11) | _BV(WGM10));											
	TCCR1B |= _BV(WGM12);					
	TIMSK |= _BV(OCIE1A);				
}


// schimbare stare LED 
ISR(TIMER1_COMPA_vect) {	
	PORTD ^= _BV(PD1); 	//port D, pin 7 XOR 1 => alterneaza starea LEDului
}


int main() {
	int i;
	
	// activeaza intreruperile
	sei();				
	
	// setare directie
	DDRD = 0xFF;
	PORTD = 0;	
	
	// setare timer	
	initTimer();
	
	/* 
	PD5: linia verde
	PD7: linia rosie
	PD6: coloana
	activare linie:0
	activare coloana:1	
	*/
	
	//while (1) {	
	
	for(i=0;i<5;i++) { //4
		_delay_ms(600);
		PORTD |= (1<<PD6); // activare coloana
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(600);
		PORTD = 0;
		_delay_ms(600);
		PORTD |= (1<<PD6); // activare coloana
		PORTD |= (1<<PD7); // dezactivare linia verde
	}

	PORTD = 0;
	_delay_ms(1000);

	for(i=0;i<5;i++) {
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(600);
		PORTD |= (1<<PD5); // dezactivare linia verde
		_delay_ms(200);
		PORTD |= (0<<PD7); // activare linia rosie
		PORTD |= (1<<PD5); // dezactivare linia verde
		_delay_ms(600);
		PORTD = 0;
	}

	//DDRD &= 0x0;
	PORTD = 0;
	_delay_ms(1000);

	
	for(i=0;i<3;i++) { //5
		PORTD |= (1<<PD5); // dezactivare linia verde
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
		PORTD = 0;
		_delay_ms(300);
	}
	
	/*
	PORTD = 0;
	_delay_ms(1000);

	for(i=0;i<3;i++) { //5
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
		PORTD = 0;
		_delay_ms(300);
	}	
	*/	
	
	PORTD = 0;
	_delay_ms(1000);
	
	for (i=0; i< 3; i++) {
		PORTD |= (1<<PD6); // activare coloana
		PORTD |= (0<<PD5); // dezactivare linia verde
		_delay_ms(200);
		PORTD |= (1<<PD6); // activare coloana
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(200);
	}
	
	PORTD = 0;
	_delay_ms(1000);
	
	
	for(i=0;i<3;i++) { //5
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
		PORTD = 0;
		_delay_ms(300);
		PORTD |= (1<<PD5); // dezactivare linia verde
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
		_delay_ms(300);
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
	}	

	PORTD = 0;
	_delay_ms(1000);	

	for(i=0;i<5;i++) {
		PORTD |= (1<<PD7); // dezactivare linia rosie
		_delay_ms(900);
		PORTD |= (1<<PD6); // activare coloana
		_delay_ms(200);
		PORTD = 0;
		_delay_ms(300);
	}
	
	//}

	return 0;
}
